<template>
  <b-overlay
    id="overlay-background"
    no-wrap
    :fixed="true"
    :show="isWaitingForResponse"
    :opacity="0.9"
    :z-index="1000"
    :blur="''"
  >
    <template #overlay>
      <div class="text-center">
        <h5 class="mb-3">{{ textBefore }}</h5>
        <b-spinner
          label="Loading ..."
          class="b-spinner-opts"
          :style="{ color: color }"
        >
        </b-spinner>
        <h5 class="mt-3">{{ textAfter }}</h5>
      </div>
    </template>
  </b-overlay>
</template>

<script lang="ts">
import type { TranslateResult } from "vue-i18n";

export default {
  name: "LoadingSpinner",

  props: {
    color: {
      default: "#00549f",
      type: String,
    },
    isWaitingForResponse: {
      default: false,
      type: Boolean,
    },
    textBefore: {
      default: "",
      type: String,
    },
    textAfter: {
      default: "",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
  },
};
</script>

<style>
.b-spinner-opts {
  height: 8rem;
  width: 8rem;
}
</style>
